#include <string.h>
#include <stdio.h>

///===========================================
#pragma pack(push,1)
typedef struct
{
char	*name;
void	*data;
} kol_struct_import;
#pragma pack(pop)

kol_struct_import* kol_cofflib_load(char *name)
{
    kol_struct_import* table;
    __asm__ __volatile__(
    "int $0x40"
    :"=a"(table)
    :"a"(68), "b"(19), "c"(name));
    return table;
}


void* kol_cofflib_procload (kol_struct_import *imp, char *name)
{
	int i;
	for (i=0;;i++)
		if ( NULL == ((imp+i) -> name))
			break;
		else
			if ( 0 == strcmp(name, (imp+i)->name) )
				return (imp+i)->data;
	return NULL;
}


unsigned kol_cofflib_procnum (kol_struct_import *imp)
{
	unsigned i, n;

	for (i=n=0;;i++)
		if ( NULL == ((imp+i) -> name))
			break;
		else
			n++;

	return n;
}


void kol_cofflib_procname (kol_struct_import *imp, char *name, unsigned n)
{
	unsigned i;
	*name = 0;

	for (i=0;;i++)
		if ( NULL == ((imp+i) -> name))
			break;
		else
			if ( i == n )
				{
				strcpy(name, ((imp+i)->name));
				break;
				}

}
///===========================================


int main(int argc, char** argv)
{
	freopen("cobj.txt", "w", stdout);
	
	char name[256];
	
	kol_struct_import *imp;

	imp = kol_cofflib_load(argv[1]);
	if (imp == NULL)
		return 0;

	for (int i = 0; i < kol_cofflib_procnum(imp); i++)
	{
		kol_cofflib_procname (imp, name, i);
		printf("%s\n", name);
	}
	return 0;
}
